/******************************************************************************
 *
 * LF.net ipcount $Id$
 *
 * ipcount snifft auf einem Netzwerk Interface die Pakete, und sortiert die
 * Anzahl der Pakete und deren Groessen-Summe in eine Matrix mit src:dst 
 * als Key ein. ipcount wird zu Accounting Zwecken verwendet.
 *
 * 
 * mah, Thu Jul 23 09:58:15 CEST 2009
 * - initiale Version, Rewrite der Version 3
 *
 ******************************************************************************/

#include "ipcount_error.h"
#include <sstream>
#include <syslog.h>

ipcount_error::ipcount_error(const string &error) :
	m_message(error)
{
}

ipcount_error::~ipcount_error() throw()
{
}

const char* ipcount_error::what() const throw ()
{
	return m_message.c_str();
}

ipcount_error &operator << (ipcount_error &e, const string &s)
{
        e.m_message += s;
        return e;
}

ipcount_error &operator << (ipcount_error &e, const int i)
{
        stringstream ss;
        ss << i;
        e.m_message += ss.str();
        return e;
}

std::ostream &operator << (std::ostream &o, const ipcount_error &e)
{
        o << e.m_message;
        return o;
}

// facility: LOG_DAEMON
// priority: LOG_ALERT, LOG_CRIT, LOG_ERR, LOG_WARNING, LOG_NOTICE, LOG_INFO
void ipcount_error::log2syslog(const std::exception &e, 
		int facility, int priority) 
{
	// LOG_CONS: Write  directly  to  system  console  if there is an error
	// while sending to system logger.

	openlog("ipcount", LOG_CONS | LOG_PID | LOG_PERROR, facility);
	syslog(priority,"%s",e.what());
}

