/******************************************************************************
 *
 * LF.net ipcount $Id$
 *
 * ipcount snifft auf einem Netzwerk Interface die Pakete, und sortiert die
 * Anzahl der Pakete und deren Groessen-Summe in eine Matrix mit src:dst 
 * als Key ein. ipcount wird zu Accounting Zwecken verwendet.
 *
 * 
 * mah, Thu Jul 23 09:58:15 CEST 2009
 * - initiale Version, Rewrite der Version 3
 *
 ******************************************************************************/

#ifndef IPCOUNT_ERROR
#define IPCOUNT_ERROR

#include <string>
#include <syslog.h>

using namespace std;

// ipcount Exception Klasse; wird verwendet, um "eigene" Fehler zu behandeln
class ipcount_error : public std::exception
{
	public:
		ipcount_error(const string &error);
		virtual ~ipcount_error() throw ();
		virtual const char* what() const throw ();
		static void log2syslog(const std::exception &e, 
				int facility, int priority);
	protected:
		string m_message;
		friend std::ostream &operator << (std::ostream &o, 
				const ipcount_error &e);
		friend ipcount_error &operator << (ipcount_error &e, 
				const string &s);
		friend ipcount_error &operator << (ipcount_error &e, 
				const int i);

};

// Operatoren, um eine Exception wie einen Stream mit Daten fuettern
// zu koennen
ipcount_error &operator << (ipcount_error &e, const string &s);
ipcount_error &operator << (ipcount_error &e, const int i);
std::ostream &operator << (std::ostream &o, const ipcount_error &e);


#endif
